<?php

namespace fk_\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KFaturaTesellumEkHizmet StructType
 * @subpackage Structs
 */
class KFaturaTesellumEkHizmet extends Entity
{
    /**
     * The KDVOrani
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $KDVOrani;
    /**
     * The ArtisOranTutari
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $ArtisOranTutari;
    /**
     * The EkHizmet
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \fk_\StructType\KEkHizmetPointer
     */
    public $EkHizmet;
    /**
     * The Fiyat
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \fk_\StructType\DovizliTutar
     */
    public $Fiyat;
    /**
     * The KDVTutari
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \fk_\StructType\DovizliTutar
     */
    public $KDVTutari;
    /**
     * The Fatura
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \fk_\StructType\KFaturaPointer
     */
    public $Fatura;
    /**
     * The Tesellum
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \fk_\StructType\KTesellumPointer
     */
    public $Tesellum;
    /**
     * The FiyatHesaplamaAciklamasi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $FiyatHesaplamaAciklamasi;
    /**
     * Constructor method for KFaturaTesellumEkHizmet
     * @uses KFaturaTesellumEkHizmet::setKDVOrani()
     * @uses KFaturaTesellumEkHizmet::setArtisOranTutari()
     * @uses KFaturaTesellumEkHizmet::setEkHizmet()
     * @uses KFaturaTesellumEkHizmet::setFiyat()
     * @uses KFaturaTesellumEkHizmet::setKDVTutari()
     * @uses KFaturaTesellumEkHizmet::setFatura()
     * @uses KFaturaTesellumEkHizmet::setTesellum()
     * @uses KFaturaTesellumEkHizmet::setFiyatHesaplamaAciklamasi()
     * @param float $kDVOrani
     * @param float $artisOranTutari
     * @param \fk_\StructType\KEkHizmetPointer $ekHizmet
     * @param \fk_\StructType\DovizliTutar $fiyat
     * @param \fk_\StructType\DovizliTutar $kDVTutari
     * @param \fk_\StructType\KFaturaPointer $fatura
     * @param \fk_\StructType\KTesellumPointer $tesellum
     * @param string $fiyatHesaplamaAciklamasi
     */
    public function __construct($kDVOrani = null, $artisOranTutari = null, \fk_\StructType\KEkHizmetPointer $ekHizmet = null, \fk_\StructType\DovizliTutar $fiyat = null, \fk_\StructType\DovizliTutar $kDVTutari = null, \fk_\StructType\KFaturaPointer $fatura = null, \fk_\StructType\KTesellumPointer $tesellum = null, $fiyatHesaplamaAciklamasi = null)
    {
        $this
            ->setKDVOrani($kDVOrani)
            ->setArtisOranTutari($artisOranTutari)
            ->setEkHizmet($ekHizmet)
            ->setFiyat($fiyat)
            ->setKDVTutari($kDVTutari)
            ->setFatura($fatura)
            ->setTesellum($tesellum)
            ->setFiyatHesaplamaAciklamasi($fiyatHesaplamaAciklamasi);
    }
    /**
     * Get KDVOrani value
     * @return float
     */
    public function getKDVOrani()
    {
        return $this->KDVOrani;
    }
    /**
     * Set KDVOrani value
     * @param float $kDVOrani
     * @return \fk_\StructType\KFaturaTesellumEkHizmet
     */
    public function setKDVOrani($kDVOrani = null)
    {
        // validation for constraint: float
        if (!is_null($kDVOrani) && !(is_float($kDVOrani) || is_numeric($kDVOrani))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($kDVOrani, true), gettype($kDVOrani)), __LINE__);
        }
        $this->KDVOrani = $kDVOrani;
        return $this;
    }
    /**
     * Get ArtisOranTutari value
     * @return float
     */
    public function getArtisOranTutari()
    {
        return $this->ArtisOranTutari;
    }
    /**
     * Set ArtisOranTutari value
     * @param float $artisOranTutari
     * @return \fk_\StructType\KFaturaTesellumEkHizmet
     */
    public function setArtisOranTutari($artisOranTutari = null)
    {
        // validation for constraint: float
        if (!is_null($artisOranTutari) && !(is_float($artisOranTutari) || is_numeric($artisOranTutari))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($artisOranTutari, true), gettype($artisOranTutari)), __LINE__);
        }
        $this->ArtisOranTutari = $artisOranTutari;
        return $this;
    }
    /**
     * Get EkHizmet value
     * @return \fk_\StructType\KEkHizmetPointer|null
     */
    public function getEkHizmet()
    {
        return $this->EkHizmet;
    }
    /**
     * Set EkHizmet value
     * @param \fk_\StructType\KEkHizmetPointer $ekHizmet
     * @return \fk_\StructType\KFaturaTesellumEkHizmet
     */
    public function setEkHizmet(\fk_\StructType\KEkHizmetPointer $ekHizmet = null)
    {
        $this->EkHizmet = $ekHizmet;
        return $this;
    }
    /**
     * Get Fiyat value
     * @return \fk_\StructType\DovizliTutar|null
     */
    public function getFiyat()
    {
        return $this->Fiyat;
    }
    /**
     * Set Fiyat value
     * @param \fk_\StructType\DovizliTutar $fiyat
     * @return \fk_\StructType\KFaturaTesellumEkHizmet
     */
    public function setFiyat(\fk_\StructType\DovizliTutar $fiyat = null)
    {
        $this->Fiyat = $fiyat;
        return $this;
    }
    /**
     * Get KDVTutari value
     * @return \fk_\StructType\DovizliTutar|null
     */
    public function getKDVTutari()
    {
        return $this->KDVTutari;
    }
    /**
     * Set KDVTutari value
     * @param \fk_\StructType\DovizliTutar $kDVTutari
     * @return \fk_\StructType\KFaturaTesellumEkHizmet
     */
    public function setKDVTutari(\fk_\StructType\DovizliTutar $kDVTutari = null)
    {
        $this->KDVTutari = $kDVTutari;
        return $this;
    }
    /**
     * Get Fatura value
     * @return \fk_\StructType\KFaturaPointer|null
     */
    public function getFatura()
    {
        return $this->Fatura;
    }
    /**
     * Set Fatura value
     * @param \fk_\StructType\KFaturaPointer $fatura
     * @return \fk_\StructType\KFaturaTesellumEkHizmet
     */
    public function setFatura(\fk_\StructType\KFaturaPointer $fatura = null)
    {
        $this->Fatura = $fatura;
        return $this;
    }
    /**
     * Get Tesellum value
     * @return \fk_\StructType\KTesellumPointer|null
     */
    public function getTesellum()
    {
        return $this->Tesellum;
    }
    /**
     * Set Tesellum value
     * @param \fk_\StructType\KTesellumPointer $tesellum
     * @return \fk_\StructType\KFaturaTesellumEkHizmet
     */
    public function setTesellum(\fk_\StructType\KTesellumPointer $tesellum = null)
    {
        $this->Tesellum = $tesellum;
        return $this;
    }
    /**
     * Get FiyatHesaplamaAciklamasi value
     * @return string|null
     */
    public function getFiyatHesaplamaAciklamasi()
    {
        return $this->FiyatHesaplamaAciklamasi;
    }
    /**
     * Set FiyatHesaplamaAciklamasi value
     * @param string $fiyatHesaplamaAciklamasi
     * @return \fk_\StructType\KFaturaTesellumEkHizmet
     */
    public function setFiyatHesaplamaAciklamasi($fiyatHesaplamaAciklamasi = null)
    {
        // validation for constraint: string
        if (!is_null($fiyatHesaplamaAciklamasi) && !is_string($fiyatHesaplamaAciklamasi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fiyatHesaplamaAciklamasi, true), gettype($fiyatHesaplamaAciklamasi)), __LINE__);
        }
        $this->FiyatHesaplamaAciklamasi = $fiyatHesaplamaAciklamasi;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \fk_\StructType\KFaturaTesellumEkHizmet
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
